#include<stdio.h>
#include<cstring>
#include<string>
#include<iostream>
#include<algorithm>
#include<cstdlib>
using namespace std;
char s[1048576];
char ori[1048576];
int n;
int last[1048576];
int cnt,head,sum;
inline bool check(){
	int tmp=0;
	for(int i=1;i<=n;i++){
		if(s[i]=='(')
			tmp++;
		if(s[i]==')')
			tmp--;
		if(tmp<0) return false;
	}
	if(tmp>0) return false;
	return true;
}
inline bool work(){
	
	int p1=last[head];
	head++;
	int p2=last[head];
	s[p1]='(';
	s[p2]=')';
	if(!check())
		return false;
	s[p1]=')';
	s[p2]='(';
	if(!check())
		return false;
	return true;
}

int value[4];

int main(){
	while(scanf("%s",s+1)!=EOF){
		n=strlen(s+1);
		for(int i=1;i<=n;i++)
			ori[i]=s[i];
		if(n==0){
			puts("Unique");
			continue;
		}
		if(n&1){
			puts("None");
			continue;
		}
		value[1]=0,value[2]=0;
		
		for(int ppp=1;ppp<=2;ppp++){
			//inv
			if(ppp==2){
				for(int i=1;i<=n;i++){
					if(ori[n-i+1]=='?')
						s[i]='?';
					else{
						if(ori[n-i+1]=='(')
							s[i]=')';
						else
							s[i]='(';
					}
				}
			}
				
			sum=0,cnt=0,head=1;		
			bool flag=true;
			for(int i=1;i<=n;i++){
				if(s[i]=='(')
					sum++;
				if(s[i]=='?')
					last[++cnt]=i;
				if(s[i]==')'){
					if(sum>0) 
						sum--;
					else{
						if(cnt>=head){
							s[last[head]]='(';
							head++;
						}
						else{
							flag=false;
							break;
						}
					}
				}	
			}
		
			if(!flag){
				//puts("None");
				value[ppp]=0;
				continue;
			}
		
			if(sum>0){
				int del=cnt-head+1;
				if(sum>del){
					//puts("None");
					value[ppp]=0;
					continue;
				}
				else{
					del-=sum;
					if(del>=2){
						//puts("Many");
						value[ppp]=2;
						continue;
					}
					else{
						//puts("Unique");
						value[ppp]=1;
						continue;
					}
				}
				continue;	
			}
		
			else{
				int del=cnt-head+1;
				if(del==0){
					//puts("Unique");
					value[ppp]=1;
					continue;
				}
				if(del>=4){
					//puts("Many");
					value[ppp]=2;
					continue;
				}
				if(del==2){
					if(work()){
						//puts("Many");
						value[ppp]=2;
						continue;
					}
					else{
						//puts("Unique");
						value[ppp]=1;
						continue;
					}
				}
				continue;
			}
	
		}
		int ans;
		ans=min(value[1],value[2]);
		if(ans==0)
			puts("None");
		if(ans==1)
			puts("Unique");
		if(ans==2)
			puts("Many");
	}
	return 0;
}

